<script>
import edit from "@/components/modal/image/MI-image";
import {
    BButton,
    BIconCamera,
    BIconCameraFill,
    BIconImage,
    BImg,
    BLink,
    BSkeleton,
} from "bootstrap-vue";
export default {
    data() {
        return {
            imageLoad: false,
        };
    },
    props: {
        path: {
            type: String,
            default: "edit",
        },
        item: {
            type: [Array, Object],
            default: () => [],
        },
    },
    components: {
        BIconImage,
        BImg,
        BLink,
        edit,
    },
    render(h) {
        let vm = this;
        let env = vm.path == "edit";
        let edit_method = env ?
            {
                click(e) {
                    vm.openModal();
                },
            } :
            {};

        let b_Link = this.item.content.url !== "" ? BLink : "div";
        let b_link_attrs =
            this.item.content.url !== "" ?
            {
                href: this.item.content.url,
                target: "_blank",
            } :
            {};
        let edit_modal = env ?
            h(edit, {
                props: {
                    index: this.item.id,
                    default_image: this.item.content.img,
                    mode: "gallery",
                },
            }) :
            [];

        let mask = env ?
            h(
                "div", {
                    class: ["mask"],
                    on: edit_method,
                },
                [
                    h(BIconCameraFill, {
                        class: ["mask_cam"],
                        props: {
                            variant: "light",
                            "font-scale": "1.5",
                        },
                    }),
                ]
            ) :
            [];
        let skeleton_img = env ?
            h(BSkeleton, {
                style: {
                    display: this.imageLoad ? "block" : "none",
                    position: "absolute",
                    top: "0",
                    left: "0",
                    width: "100%",
                    height: "100%",
                    "background-color": "#E2E2E2",
                },
            }) :
            [];

        let res = h("div", {}, [
            h(
                "div", {
                    attrs: {
                        id: "imageBlock",
                    },
                    style: {
                        display: "flex",
                        justifyContent: "center",
                        flexWrap: "wrap",
                        height: "auto",
                        cursor: env ?
                            "pointer" :
                            this.item.content.url == "" ?
                            "auto" :
                            "pointer",
                    },
                },
                [
                    mask,
                    h(
                        b_Link, {
                            attrs: b_link_attrs,
                            style: {
                                display: "block",
                                width: "100%",
                            },
                        },
                        [
                            skeleton_img,
                            h(BImg, {
                                attrs: {
                                    alt: this.item.content.alt,
                                    title: this.item.content.title,
                                    src: this.item.content.img,
                                    fluid: true,
                                },
                                style: {
                                    width: "100%",
                                },
                            }),
                        ]
                    ),
                ]
            ),
            edit_modal,
        ]);

        return res;
    },
    methods: {
        openModal() {
            console.log(`edit_image_gallery_${this.item.id}`);
            this.$bvModal.show(`edit_image_gallery_${this.item.id}`);
        },
    },
    mounted() {
        this.$root.$on("send::imageLoad" + this.item.id, (boolean) => {
            this.imageLoad = boolean;
        });
    },
};
</script>

<style lang="scss">
#imageBlock {
    position: relative;
    display: flex;
    justify-content: center;
    flex-wrap: wrap;
    height: auto;

    .mask {
        opacity: 0;
        position: absolute;
        width: 100%;
        height: 100%;
        transition: all 0.3s ease-in-out;

        &_cam {
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
        }

        &:hover {
            opacity: 1;
            background-color: rgba($color: #000000, $alpha: 0.3);
        }
    }

    a {
        display: block;
        width: 100%;
    }

    img {
        width: 100%;
    }
}
</style>
